<template>
  <CmsGsGenericElement :slotContext="product" v-if="wrapInElement">
    <SwPluginSlot name="gs-product-card" :slot-context="product">
      <div @click="!isSelfService ? openQuickViewModal() : null">
        <SfProductCard
          :title="name"
          :image="imageUrl"
          :special-price="formatPrice(specialPrice)"
          :regular-price="formatPrice(regularPrice)"
          image-width="700"
          image-height="1000"
          class="sw-product-card"
          :show-add-to-cart-button="true"
          @click="
            isSelfService
              ? openDynamicPage({
                  type: 'product',
                  opened: true,
                  productId: product.id,
                })
              : null
          "
        >
          <template #image>
            <SwImage
              :src="imageUrl"
              :title="name"
              :alt="name"
              style="cursor: pointer"
              width="200"
              height="400"
              :loading="'eager'"
              @click.native="!isSelfService ? openQuickViewModal() : openDynamicPage({
                type: 'product',
                opened: true,
                productId: product.id,
              })"
            />
          </template>
          <template #wishlist-icon>
            <template
              v-if="
                isClient ||
                (isGuide && currentClientForGuide && allowUserActionsForGuide)
              "
            >
              <SwButton
                class="sw-gs-product-card-like-btn color-light is-circle"
                :class="{ 'is-on-list': productLiked }"
                :title="$t('Like')"
                :disabled="likeLoading"
                @click.stop="likeHandler"
              >
                <SfLoader :loading="likeLoading">
                  <SwGsIconThumbsUpSmall
                    class="sw-gs-product-card-like-icon color-dark-secondary size-sm"
                  />
                </SfLoader>
              </SwButton>

              <SwButton
                v-if="dislikeActive"
                class="sw-gs-product-card-dislike-btn color-light is-circle"
                :class="{
                  'is-on-list': productDisliked,
                  'not-liked': !productLiked,
                }"
                :title="$t('Dislike')"
                :disabled="dislikeLoading"
                @click.stop="dislikeHandler"
              >
                <SfLoader :loading="dislikeLoading">
                  <SwGsIconThumbsDownSmall
                    class="sw-gs-product-card-dislike-icon color-dark-secondary size-sm"
                  />
                </SfLoader>
              </SwButton>
            </template>
            <span v-else></span>
          </template>

          <template
            #add-to-cart="{
              title,
            }"
          >
            <template
              v-if="isClient || (isGuide && currentClientCartPermissions)"
            >
              <SwGsAddToCartBtn :title="title" :product="product" />
            </template>
            <span v-else></span>
          </template>
        </SfProductCard>
      </div>
    </SwPluginSlot>
  </CmsGsGenericElement>
  <div v-else>
    <slot />
  </div>
</template>

<script lang="ts">
import { SfProductCard, SfLoader } from "@storefront-ui/vue";
import SwButton from "@/components/atoms/SwButton.vue";
import {
  getProductThumbnailUrl,
  getProductTierPrices,
  getProductName,
  getProductCalculatedPrice,
  getProductCalculatedListingPrice,
  getProductPriceDiscount,
} from "@shopware-pwa/helpers";
import getResizedImage from "@/helpers/images/getResizedImage.js";
import { computed, ref, unref } from "@vue/composition-api";
import { useLikeList } from "../logic/composables/useLikeList";
import {
  SwGsIconCart,
  SwGsIconThumbsUpSmall,
  SwGsIconThumbsDownSmall,
} from "./icons";
import { useState } from "../logic/composables/useState";
import { useDynamicPage } from "../logic/composables/useDynamicPage";
import { useQuickView } from "../logic/composables/useQuickView";
import { useAppointment } from "../logic/composables/useAppointment";
import { useGsCart } from "../logic/composables/useGsCart";
import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";
import SwGsAddToCartBtn from "./SwGsAddToCartBtn.vue";
import SwImage from "@/components/atoms/SwImage.vue";
import { usePriceFilter } from "../logic/composables/usePriceFilter";

const CmsGsGenericElement = () => import("./cms/CmsGsGenericElement.vue");

export default {
  components: {
    CmsGsGenericElement,
    SfLoader,
    SfProductCard,
    SwButton,
    SwPluginSlot,
    SwGsIconThumbsUpSmall,
    SwGsIconThumbsDownSmall,
    SwGsAddToCartBtn,
    SwImage,
    SwGsIconCart,
  },
  props: {
    slotContext: {
      type: [Object, Array, String],
      default: null,
    },
    dislikeActive: {
      type: Boolean,
      default: true,
    },
  },
  setup(props, { root }) {
    const layoutName = ref(root.layoutName);
    const wrapInElement = computed(
      () => layoutName.value.includes('PresentationLayout')
    );

    // don't wrap the element if it is not the presentation layout
    if (!wrapInElement.value) {
      return {
        wrapInElement,
      };
    }

    const product = ref(props.slotContext);
    const { currentClientCartPermissions } = useGsCart();
    const { openQuickView } = useQuickView();
    const { formatPrice } = usePriceFilter();

    const name = computed(() => getProductName({ product: product.value }));

    const imageUrl = computed(() =>
      getResizedImage(getProductThumbnailUrl(product.value), {
        width: 180,
        height: 200,
        quality: 100,
      })
    );

    const tierPrices = computed(() => getProductTierPrices(product.value));

    const specialPrice = computed(() =>
      tierPrices.value.length
        ? undefined
        : getProductPriceDiscount(product.value) &&
          getProductCalculatedPrice(product.value)
    );

    const regularPrice = computed(
      () =>
        (tierPrices.value.length &&
          tierPrices.value[0] &&
          tierPrices.value[0].unitPrice) ||
        getProductCalculatedListingPrice(product.value)
    );

    const { currentClientForGuide, stateForAll } = useState();
    const { isGuide, isClient, isSelfService } = useAppointment();
    const {
      like,
      dislike,
      removeFromLikeList,
      removeFromDislikeList,
      productLiked,
      productDisliked,
    } = useLikeList(product.value);
    const { openDynamicPage } = useDynamicPage();

    const likeLoading = ref(false);
    const dislikeLoading = ref(false);

    async function likeHandler() {
      likeLoading.value = true;
      if (productLiked.value === true) {
        await removeFromLikeList();
      } else {
        await like();
      }
      likeLoading.value = false;
    }

    async function dislikeHandler() {
      dislikeLoading.value = true;
      if (productDisliked.value === true) {
        await removeFromDislikeList();
      } else {
        await dislike();
      }
      dislikeLoading.value = false;
    }

    function openQuickViewModal() {
      openQuickView(product.value);
    }

    return {
      wrapInElement,
      product,
      name,
      imageUrl,
      tierPrices,
      specialPrice,
      regularPrice,
      formatPrice,
      currentClientForGuide,
      isGuide,
      isClient,
      isSelfService,
      likeHandler,
      dislikeHandler,
      productLiked,
      productDisliked,
      likeLoading,
      dislikeLoading,
      openDynamicPage,
      openQuickViewModal,
      currentClientCartPermissions,
      allowUserActionsForGuide: computed(
        () => stateForAll.value?.allowUserActionsForGuide
      ),
    };
  },
};
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";

.sw-product-card {
  width: 100%;
  padding: var(--spacer-2xs);
  max-width: 100%;

  @include for-tablet {
    max-width: var(--product-card-max-width, 10.625rem);
  }

  &:hover {
    @include for-desktop {
      .sw-gs-add-to-cart-btn {
        --product-card-add-button-opacity: 1;
        --product-card-add-button-display: flex;
      }

      .sw-gs-product-card-like-btn,
      .sw-gs-product-card-dislike-btn {
        opacity: 1;

        &.not-liked {
          position: relative;
          top: auto;
        }
      }
    }
  }
}

.sw-gs-product-card-like-btn,
.sw-gs-product-card-dislike-btn {
  opacity: 1;

  @include for-desktop {
    opacity: 0;
    transition: opacity 0.4s ease-in-out 0s;
  }
}

.sw-gs-product-card-like-btn {
  margin-bottom: var(--spacer-xs);

  &.is-on-list {
    opacity: 1;

    .sw-gs-product-card-like-icon {
      --icon-color: var(--c-success);
    }
  }
}

.sw-gs-product-card-dislike-btn {
  &.is-on-list {
    opacity: 1;

    .sw-gs-product-card-dislike-icon {
      --icon-color: var(--c-danger);
    }

    &.not-liked {
      @include for-desktop {
        position: absolute;
        top: 0; // to be in the corner of the box
      }
    }
  }
}

.sw-gs-add-to-cart-btn {
  --product-card-add-button-opacity: 1;
  --product-card-add-button-display: flex;

  @include for-desktop {
    --product-card-add-button-opacity: 0;
    --product-card-add-button-display: none;
  }
}

::v-deep {
  .sf-product-card {
    max-width: 100%;

    @include for-tablet {
      max-width: var(--product-card-max-width, 10.625rem);
    }
  }

  .sf-product-card__image-wrapper {
    min-height: 120px;
  }

  .sf-product-card__wishlist-icon {
    display: block;
    top: var(--spacer-2xs);
    right: var(--spacer-2xs);
    opacity: 1; // moved transition onto buttons themselves
    transition: none;
  }

  .sf-loader {
    width: 22px;
    height: 22px;
  }

  .sf-loader__overlay {
    background: none;
  }
}
</style>
